# ruff: noqa: F401

from . import _cache, _magic, ai, credentials, quick, raster, templates, utils, warnings
from ._options import PREVIEW_DEFAULT_BASE_URL as _PREVIEW_DEFAULT_BASE_URL
from ._options import PROD_DEFAULT_BASE_URL as _PROD_DEFAULT_BASE_URL
from ._options import STAGING_DEFAULT_BASE_URL as _STAGING_DEFAULT_BASE_URL
from ._options import _env, options, set_option
from ._project import Project, open_project
from ._public_api import (
    _whoami,
    delete,
    download,
    get,
    get_jobs,
    get_udfs,
    ingest,
    ingest_nongeospatial,
    job,
    join,
    list,
    load_job,
    map,
    open_table,
)
from ._public_api import plot as _plot
from ._public_api import sign_url, sign_url_prefix, union_tables, upload, zip_tables
from ._udf import load_udf, udf
from .api import FusedAPI, FusedDockerAPI, FusedDockerHTTPAPI
from .credentials import NotebookCredentials
from .models import VizConfig, VizLayerConfig

# Version is set to 0.0.0 as the version string is automatically generated by
# https://github.com/mtkennerly/poetry-dynamic-versioning
__version__ = "1.1.4"
